﻿using FluentValidation.AspNetCore;
using Microsoft.AspNetCore.Mvc;
using Performance.DtoModels;
using Performance.Services;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Performance.Api.Controllers
{
    [Route("api/[controller]")]
    public class ReportController : Controller
    {
        private ReportService reportService;
        public ReportController(ReportService reportService)
        {
            this.reportService = reportService;
        }

        /// <summary>
        /// 首页数据概况
        /// </summary>
        /// <returns></returns>
        [Route("survey")]
        public ApiResponse Survey()
        {
            //拿最新有效的绩效年月

            //hos_personfee 门诊患者均次  住院患者均次
            //res_baiscnorm 全部拿出来

            //xxxx年  xx月  数组 

            throw new NotImplementedException();
        }

        /// <summary>
        /// 科室医生人均绩效（含科主任）
        /// </summary>
        /// <returns></returns>
        [Route("doctoravg")]
        public ApiResponse DoctorAvg()
        {

            // res_accountdoctor 人数  所有有效绩效 （6,8）  
            throw new NotImplementedException();
        }

        /// <summary>
        /// 科室护士人均绩效（含护士长）
        /// </summary>
        /// <returns></returns>
        [Route("nurseavg")]
        public ApiResponse NurseAvg()
        {
            // res_accountnurse 人数  所有有效绩效 （6,8）  
            throw new NotImplementedException();
        }

        /// <summary>
        /// 门诊患者均次费用
        /// </summary>
        /// <returns></returns>
        [Route("outfeeavg")]
        public ApiResponse OutFeeAvg()
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// 住院患者均次费用
        /// </summary>
        /// <returns></returns>
        [Route("inpatfeeavg")]
        public ApiResponse InpatFeeAvg()
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// 科室药占比
        /// </summary>
        /// <returns></returns>
        [Route("medicine")]
        public ApiResponse Medicine()
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// 科室有效收入占比
        /// </summary>
        /// <returns></returns>
        [Route("income")]
        public ApiResponse Income()
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// 月群体人均绩效
        /// </summary>
        /// <param name="request"></param>
        /// <returns></returns>
        [Route("getperforavg")]
        [HttpPost]
        public ApiResponse AvgPerfor([CustomizeValidator(RuleSet = "Query"), FromBody]ReportRequest request)
        {
            var list = reportService.GetAvgPerfor(request.HospitalId);
            return new ApiResponse(ResponseType.OK, "", list);
        }


        /// <summary>
        /// 人群绩效比
        /// </summary>
        /// <param name="request"></param>
        /// <returns></returns>
        [Route("avgratio")]
        [HttpPost]
        public ApiResponse AvgRatio([CustomizeValidator(RuleSet = "Query"), FromBody]ReportRequest request)
        {
            var list = reportService.AvgRatio(request.HospitalId);
            return new ApiResponse(ResponseType.OK, "", list);
        }
    }
}